Package net.sf.saxon.tree

## Class NamespaceNode

- java.lang.Object
- - net.sf.saxon.tree.NamespaceNode

- All Implemented Interfaces:
    `javax.xml.transform.Source`, `javax.xml.transform.SourceLocator`, `GroundedValue`, `Item`, `NodeInfo`, `Sequence`, `Location`, `org.xml.sax.Locator`

      public class NamespaceNode
      extends java.lang.Object
      implements NodeInfo

  This class represents a namespace node; it is used in several tree models.

- - ### Field Summary

    - ### Fields inherited from interface net.sf.saxon.om.NodeInfo

      `IS_DTD_TYPE, IS_NILLED`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `NamespaceNode​(NodeInfo element, NamespaceBinding nscode, int position)` | Create a namespace node

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `AtomicSequence` | `atomize()` | Get the typed value.
    `int` | `compareOrder​(NodeInfo other)` | Determine the relative position of this node and another node, in document order.
    `void` | `copy​(Receiver out, int copyOptions, Location locationId)` | Copy this node to a given outputter
    `boolean` | `equals​(java.lang.Object other)` | Determine whether this is the same node as another node.
    `void` | `generateId​(FastStringBuffer buffer)` | Get a character string that uniquely identifies this node.
    `NamespaceMap` | `getAllNamespaces()` | Get all the namespace bindings that are in-scope for this element.
    `java.lang.String` | `getAttributeValue​(java.lang.String uri, java.lang.String local)` | Get the string value of a given attribute of this node
    `java.lang.String` | `getBaseURI()` | Get the Base URI for the node, that is, the URI used for resolving a relative URI contained in the node.
    `int` | `getColumnNumber()` | Get column number
    `Configuration` | `getConfiguration()` | Get the configuration
    `NamespaceBinding[]` | `getDeclaredNamespaces​(NamespaceBinding[] buffer)` | Get all namespace undeclarations and undeclarations defined on this element.
    `java.lang.String` | `getDisplayName()` | Get the display name of this node.
    `int` | `getFingerprint()` | Get fingerprint.
    `int` | `getLineNumber()` | Get line number
    `java.lang.String` | `getLocalPart()` | Get the local part of the name of this node.
    `NamePool` | `getNamePool()` | Get the NamePool that holds the namecode for this node
    `int` | `getNodeKind()` | Get the kind of node.
    `NodeInfo` | `getParent()` | Get the NodeInfo object representing the parent of this node
    `java.lang.String` | `getPrefix()` | Get the prefix of the name of the node.
    `java.lang.String` | `getPublicId()` | Get the Public ID of the entity containing the node.
    `NodeInfo` | `getRoot()` | Get the root node of the tree containing this node
    `SchemaType` | `getSchemaType()` | Get the type annotation of this node, if any.
    `java.lang.String` | `getStringValue()` | Return the string value of the node.
    `java.lang.CharSequence` | `getStringValueCS()` | Get the value of the item as a CharSequence.
    `java.lang.String` | `getSystemId()` | Get the System ID for the node.
    `TreeInfo` | `getTreeInfo()` | Get information about the tree to which this NodeInfo belongs
    `java.lang.String` | `getURI()` | Get the URI part of the name of this node.
    `boolean` | `hasChildNodes()` | Determine whether the node has any children.
    `boolean` | `hasFingerprint()` | Ask whether this NodeInfo implementation holds a fingerprint identifying the name of the node in the NamePool.
    `int` | `hashCode()` | The hashCode() method obeys the contract for hashCode(): that is, if two objects are equal (represent the same node) then they must have the same hashCode()
    `NodeInfo` | `head()` | To implement `Sequence`, this method returns the item itself
    `boolean` | `isStreamed()` | Ask whether this is a node in a streamed document
    `AxisIterator` | `iterateAxis​(int axisNumber, java.util.function.Predicate<? super NodeInfo> nodeTest)` | Return an iteration over all the nodes reached by the given axis from this node that match a given NodeTest
    `static AxisIterator` | `makeIterator​(NodeInfo element, java.util.function.Predicate<? super NodeInfo> test)` | Factory method to create an iterator over the in-scope namespace nodes of an element
    `Location` | `saveLocation()` | Get an immutable copy of this Location object.
    `void` | `setSystemId​(java.lang.String systemId)` | Set the system identifier for this Source.

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.om.GroundedValue

      `asIterable, concatenate, containsNode, effectiveBooleanValue, materialize`

    - ### Methods inherited from interface net.sf.saxon.om.Item

      `getLength, itemAt, iterate, reduce, subsequence`

    - ### Methods inherited from interface net.sf.saxon.om.NodeInfo

      `attributes, children, children, getGenre, isId, isIdref, isNilled, isSameNodeInfo, iterateAxis, toShortString`

    - ### Methods inherited from interface net.sf.saxon.om.Sequence

      `makeRepeatable`

    - ### Methods inherited from interface javax.xml.transform.Source

      `isEmpty`

- - ### Constructor Detail

    - #### NamespaceNode

          public NamespaceNode​(NodeInfo element,
                               NamespaceBinding nscode,
                               int position)

      Create a namespace node
      Parameters:
        `element` - the parent element of the namespace node
        `nscode` - the namespace code, representing the prefix and URI of the namespace binding
        `position` - maintains document order among namespace nodes for the same element

  - ### Method Detail

    - #### getTreeInfo

          public TreeInfo getTreeInfo()

      Get information about the tree to which this NodeInfo belongs
      Specified by:
        `getTreeInfo` in interface `NodeInfo`
      Returns:
        the TreeInfo
      Since:
        9.7

    - #### head

          public NodeInfo head()

      To implement `Sequence`, this method returns the item itself
      Specified by:
        `head` in interface `GroundedValue`
      Specified by:
        `head` in interface `Item`
      Specified by:
        `head` in interface `Sequence`
      Returns:
        this item

    - #### getNodeKind

          public int getNodeKind()

      Get the kind of node. This will be a value such as Type.ELEMENT or Type.ATTRIBUTE
      Specified by:
        `getNodeKind` in interface `NodeInfo`
      Returns:
        an integer identifying the kind of node. These integer values are the same as those used in the DOM
      See Also:
        `Type`

    - #### equals

          public boolean equals​(java.lang.Object other)

      Determine whether this is the same node as another node. Note: a.equals(b) if and only if generateId(a)==generateId(b). This method has the same semantics as isSameNode() in DOM Level 3, but works on Saxon NodeInfo objects rather than DOM Node objects.
      Specified by:
        `equals` in interface `NodeInfo`
      Overrides:
        `equals` in class `java.lang.Object`
      Parameters:
        `other` - the node to be compared with this node
      Returns:
        true if this NodeInfo object and the supplied NodeInfo object represent the same node in the tree.

    - #### hashCode

          public int hashCode()

      The hashCode() method obeys the contract for hashCode(): that is, if two objects are equal (represent the same node) then they must have the same hashCode()
      Specified by:
        `hashCode` in interface `NodeInfo`
      Overrides:
        `hashCode` in class `java.lang.Object`
      Since:
        8.7 Previously, the effect of the equals() and hashCode() methods was not defined. Callers should therefore be aware that third party implementations of the NodeInfo interface may not implement the correct semantics.

    - #### getSystemId

          public java.lang.String getSystemId()

      Get the System ID for the node.
      Specified by:
        `getSystemId` in interface `Location`
      Specified by:
        `getSystemId` in interface `org.xml.sax.Locator`
      Specified by:
        `getSystemId` in interface `NodeInfo`
      Specified by:
        `getSystemId` in interface `javax.xml.transform.Source`
      Specified by:
        `getSystemId` in interface `javax.xml.transform.SourceLocator`
      Returns:
        the System Identifier of the entity in the source document containing the node, or null if not known. Note this is not the same as the base URI: the base URI can be modified by xml:base, but the system ID cannot.

    - #### getPublicId

          public java.lang.String getPublicId()

      Get the Public ID of the entity containing the node.
      Specified by:
        `getPublicId` in interface `Location`
      Specified by:
        `getPublicId` in interface `org.xml.sax.Locator`
      Specified by:
        `getPublicId` in interface `NodeInfo`
      Specified by:
        `getPublicId` in interface `javax.xml.transform.SourceLocator`
      Returns:
        the Public Identifier of the entity in the source document containing the node, or null if not known or not applicable
      Since:
        9.7

    - #### getBaseURI

          public java.lang.String getBaseURI()

      Get the Base URI for the node, that is, the URI used for resolving a relative URI contained in the node. This will be the same as the System ID unless xml:base has been used.
      Specified by:
        `getBaseURI` in interface `NodeInfo`
      Returns:
        the base URI of the node

    - #### getLineNumber

          public int getLineNumber()

      Get line number
      Specified by:
        `getLineNumber` in interface `Location`
      Specified by:
        `getLineNumber` in interface `org.xml.sax.Locator`
      Specified by:
        `getLineNumber` in interface `NodeInfo`
      Specified by:
        `getLineNumber` in interface `javax.xml.transform.SourceLocator`
      Returns:
        the line number of the node in its original source document; or -1 if not available

    - #### getColumnNumber

          public int getColumnNumber()

      Get column number
      Specified by:
        `getColumnNumber` in interface `Location`
      Specified by:
        `getColumnNumber` in interface `org.xml.sax.Locator`
      Specified by:
        `getColumnNumber` in interface `NodeInfo`
      Specified by:
        `getColumnNumber` in interface `javax.xml.transform.SourceLocator`
      Returns:
        the column number of the node in its original source document; or -1 if not available

    - #### saveLocation

          public Location saveLocation()

      Get an immutable copy of this Location object. By default Location objects may be mutable, so they should not be saved for later use. The result of this operation holds the same location information, but in an immutable form.
      Specified by:
        `saveLocation` in interface `Location`
      Returns:
        an immutable copy (which may be the original object, if it is already immutable)

    - #### compareOrder

          public int compareOrder​(NodeInfo other)

      Determine the relative position of this node and another node, in document order. The other node will always be in the same document.
      Specified by:
        `compareOrder` in interface `NodeInfo`
      Parameters:
        `other` - The other node, whose position is to be compared with this node
      Returns:
        -1 if this node precedes the other node, +1 if it follows the other node, or 0 if they are the same node. (In this case, isSameNode() will always return true, and the two nodes will produce the same result for generateId())

    - #### getStringValue

          public java.lang.String getStringValue()

      Return the string value of the node. The interpretation of this depends on the type of node. For a namespace node, it is the namespace URI.
      Specified by:
        `getStringValue` in interface `GroundedValue`
      Specified by:
        `getStringValue` in interface `Item`
      Specified by:
        `getStringValue` in interface `NodeInfo`
      Returns:
        the string value of the node
      See Also:
        `Item.getStringValueCS()`

    - #### getStringValueCS

          public java.lang.CharSequence getStringValueCS()

      Get the value of the item as a CharSequence. This is in some cases more efficient than the version of the method that returns a String.
      Specified by:
        `getStringValueCS` in interface `GroundedValue`
      Specified by:
        `getStringValueCS` in interface `Item`
      Returns:
        the string value of the item
      See Also:
        `Item.getStringValue()`

    - #### hasFingerprint

          public boolean hasFingerprint()

      Ask whether this NodeInfo implementation holds a fingerprint identifying the name of the node in the NamePool. If the answer is true, then the `getFingerprint()` method must return the fingerprint of the node. If the answer is false, then the `getFingerprint()` method should throw an `UnsupportedOperationException`. In the case of unnamed nodes such as text nodes, the result can be either true (in which case getFingerprint() should return -1) or false (in which case getFingerprint may throw an exception).
      Specified by:
        `hasFingerprint` in interface `NodeInfo`
      Returns:
        true if the implementation of this node provides fingerprints.
      Since:
        9.8; previously Saxon relied on using `FingerprintedNode` as a marker interface.

    - #### getFingerprint

          public int getFingerprint()

      Get fingerprint. The fingerprint is a coded form of the expanded name of the node: two nodes with the same name code have the same namespace URI and the same local name. A fingerprint of -1 should be returned for a node with no name.
      Specified by:
        `getFingerprint` in interface `NodeInfo`
      Returns:
        an integer fingerprint; two nodes with the same fingerprint have the same expanded QName

    - #### getLocalPart

          public java.lang.String getLocalPart()

      Get the local part of the name of this node. This is the name after the ":" if any.
      Specified by:
        `getLocalPart` in interface `NodeInfo`
      Returns:
        the local part of the name. For an unnamed node, returns "". Unlike the DOM interface, this returns the full name in the case of a non-namespaced name.

    - #### getURI

          public java.lang.String getURI()

      Get the URI part of the name of this node. This is the URI corresponding to the prefix, or the URI of the default namespace if appropriate.
      Specified by:
        `getURI` in interface `NodeInfo`
      Returns:
        The URI of the namespace of this node. Since the name of a namespace node is always an NCName (the namespace prefix), this method always returns "".

    - #### getDisplayName

          public java.lang.String getDisplayName()

      Get the display name of this node. For elements and attributes this is [prefix:]localname. For unnamed nodes, it is an empty string.
      Specified by:
        `getDisplayName` in interface `NodeInfo`
      Returns:
        The display name of this node. For a node with no name, return an empty string.

    - #### getPrefix

          public java.lang.String getPrefix()

      Get the prefix of the name of the node. This is defined only for elements and attributes. If the node has no prefix, or for other kinds of node, return a zero-length string.
      Specified by:
        `getPrefix` in interface `NodeInfo`
      Returns:
        The prefix of the name of the node.

    - #### getConfiguration

          public Configuration getConfiguration()

      Get the configuration
      Specified by:
        `getConfiguration` in interface `NodeInfo`
      Returns:
        the Configuration to which the tree belongs. The default implementation invokes `getTreeInfo().getConfiguration()`.

    - #### getNamePool

          public NamePool getNamePool()

      Get the NamePool that holds the namecode for this node
      Returns:
        the namepool

    - #### getSchemaType

          public SchemaType getSchemaType()

      Get the type annotation of this node, if any. The type annotation is represented as SchemaType object.

      Types derived from a DTD are not reflected in the result of this method.

      Specified by:
        `getSchemaType` in interface `NodeInfo`
      Returns:
        For element and attribute nodes: the type annotation derived from schema validation (defaulting to xs:untyped and xs:untypedAtomic in the absence of schema validation). For comments, text nodes, processing instructions, and namespaces: null. For document nodes, either xs:untyped if the document has not been validated, or xs:anyType if it has.
      Since:
        9.4

    - #### getParent

          public NodeInfo getParent()

      Get the NodeInfo object representing the parent of this node
      Specified by:
        `getParent` in interface `NodeInfo`
      Returns:
        the parent of this node; null if this node has no parent

    - #### iterateAxis

          public AxisIterator iterateAxis​(int axisNumber,
                                          java.util.function.Predicate<? super NodeInfo> nodeTest)

      Return an iteration over all the nodes reached by the given axis from this node that match a given NodeTest
      Specified by:
        `iterateAxis` in interface `NodeInfo`
      Parameters:
        `axisNumber` - an integer identifying the axis; one of the constants defined in class net.sf.saxon.om.Axis
        `nodeTest` - A pattern to be matched by the returned nodes; nodes that do not match this pattern are not included in the result
      Returns:
        a NodeEnumeration that scans the nodes reached by the axis in turn.
      Throws:
        `java.lang.UnsupportedOperationException` - if the namespace axis is requested and this axis is not supported for this implementation.
      See Also:
        `AxisInfo`

    - #### getAttributeValue

          public java.lang.String getAttributeValue​(java.lang.String uri,
                                                    java.lang.String local)

      Get the string value of a given attribute of this node
      Specified by:
        `getAttributeValue` in interface `NodeInfo`
      Parameters:
        `uri` - the namespace URI of the attribute name. Supply the empty string for an attribute that is in no namespace
        `local` - the local part of the attribute name.
      Returns:
        the attribute value if it exists, or null if it does not exist. Always returns null if this node is not an element.
      Since:
        9.4

    - #### getRoot

          public NodeInfo getRoot()

      Get the root node of the tree containing this node
      Specified by:
        `getRoot` in interface `NodeInfo`
      Returns:
        the NodeInfo representing the top-level ancestor of this node. This will not necessarily be a document node

    - #### hasChildNodes

          public boolean hasChildNodes()

      Determine whether the node has any children.

      Note: the result is equivalent to `getEnumeration(Axis.CHILD, AnyNodeTest.getInstance()).hasNext()`

      Specified by:
        `hasChildNodes` in interface `NodeInfo`
      Returns:
        True if the node has one or more children

    - #### generateId

          public void generateId​(FastStringBuffer buffer)

      Get a character string that uniquely identifies this node. Note: a.isSameNode(b) if and only if generateId(a)==generateId(b)
      Specified by:
        `generateId` in interface `NodeInfo`
      Parameters:
        `buffer` - buffer to hold a string that uniquely identifies this node, across all documents.

    - #### copy

          public void copy​(Receiver out,
                           int copyOptions,
                           Location locationId)
                    throws XPathException

      Copy this node to a given outputter
      Specified by:
        `copy` in interface `NodeInfo`
      Parameters:
        `out` - the Receiver to which the node should be copied
        `copyOptions` - a selection of the options defined in `CopyOptions`
        `locationId` - If non-zero, identifies the location of the instruction
      Throws:
        `XPathException` - if any downstream error occurs

    - #### getDeclaredNamespaces

          public NamespaceBinding[] getDeclaredNamespaces​(NamespaceBinding[] buffer)

      Get all namespace undeclarations and undeclarations defined on this element.
      Specified by:
        `getDeclaredNamespaces` in interface `NodeInfo`
      Parameters:
        `buffer` - If this is non-null, and the result array fits in this buffer, then the result may overwrite the contents of this array, to avoid the cost of allocating a new array on the heap.
      Returns:
        An array of integers representing the namespace declarations and undeclarations present on this element. For a node other than an element, return null. Otherwise, the returned array is a sequence of namespace codes, whose meaning may be interpreted by reference to the name pool. The top half word of each namespace code represents the prefix, the bottom half represents the URI. If the bottom half is zero, then this is a namespace undeclaration rather than a declaration. The XML namespace is never included in the list. If the supplied array is larger than required, then the first unused entry will be set to -1.

        For a node other than an element, the method returns null.

    - #### getAllNamespaces

          public NamespaceMap getAllNamespaces()

      Get all the namespace bindings that are in-scope for this element.

      For an element return all the prefix-to-uri bindings that are in scope. This may include a binding to the default namespace (represented by a prefix of ""). It will never include "undeclarations" - that is, the namespace URI will never be empty; the effect of an undeclaration is to remove a binding from the in-scope namespaces, not to add anything.

      For a node other than an element, returns null.

      Specified by:
        `getAllNamespaces` in interface `NodeInfo`
      Returns:
        the in-scope namespaces for an element, or null for any other kind of node.

    - #### setSystemId

          public void setSystemId​(java.lang.String systemId)

      Set the system identifier for this Source.

      The system identifier is optional if the source does not get its data from a URL, but it may still be useful to provide one. The application can use a system identifier, for example, to resolve relative URIs and to include in error messages and warnings.

      Specified by:
        `setSystemId` in interface `javax.xml.transform.Source`
      Parameters:
        `systemId` - The system identifier as a URL string.

    - #### atomize

          public AtomicSequence atomize()
                                 throws XPathException

      Get the typed value.
      Specified by:
        `atomize` in interface `Item`
      Specified by:
        `atomize` in interface `NodeInfo`
      Returns:
        the typed value.
      Throws:
        `XPathException` - if the node has no typed value, for example if it is an element node with element-only content
      Since:
        8.5

    - #### isStreamed

          public boolean isStreamed()

      Description copied from interface: `NodeInfo`
      Ask whether this is a node in a streamed document
      Specified by:
        `isStreamed` in interface `Item`
      Specified by:
        `isStreamed` in interface `NodeInfo`
      Returns:
        true if the node is in a document being processed using streaming. The default implementation returns false.

    - #### makeIterator

          public static AxisIterator makeIterator​(NodeInfo element,
                                                  java.util.function.Predicate<? super NodeInfo> test)

      Factory method to create an iterator over the in-scope namespace nodes of an element
      Parameters:
        `element` - the node whose namespaces are required
        `test` - used to filter the returned nodes
      Returns:
        an iterator over the namespace nodes that satisfy the test